package gov.nih.nci.cagrid.cadsr.common;

import java.rmi.RemoteException;

/**
 * The caDSR Grid Service
 *
 * This class is autogenerated, DO NOT EDIT.
 * 
 * @created by Introduce Toolkit version 1.0
 * 
 */
public interface CaDSRServiceI {

    public gov.nih.nci.cagrid.metadata.security.ServiceSecurityMetadata getServiceSecurityMetadata() throws RemoteException ;

  /**
   * Returns all Projects registered in caDSR.
   *
   * @return e.g caCore
   */
  public gov.nih.nci.cadsr.umlproject.domain.Project[] findAllProjects() throws RemoteException ;

  /**
   * Returns all Projects registered in caDSR under the given context.
   *
   * @param context
   * @return e.g caCore
   */
  public gov.nih.nci.cadsr.umlproject.domain.Project[] findProjects(java.lang.String context) throws RemoteException ;

  /**
   * Returns all packages in the given Project.
   *
   * @param project
   *	e.g caCore
   * @return CSI type = UMLPACKAGE
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.umlproject.domain.UMLPackageMetadata[] findPackagesInProject(gov.nih.nci.cadsr.umlproject.domain.Project project) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns the Classes in the given Project.
   *
   * @param project
   *	e.g caCore
   * @return caDSR properties of the UML Class in a domain model.
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.umlproject.domain.UMLClassMetadata[] findClassesInProject(gov.nih.nci.cadsr.umlproject.domain.Project project) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns the Classes in the given Package.
   *
   * @param project
   *	e.g caCore
   * @param packageName
   * @return caDSR properties of the UML Class in a domain model.
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.umlproject.domain.UMLClassMetadata[] findClassesInPackage(gov.nih.nci.cadsr.umlproject.domain.Project project,java.lang.String packageName) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Generates caGrid standard Data Service Metadata for all Classes in the given Project.
   *
   * @param project
   *	e.g caCore
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForProject(gov.nih.nci.cadsr.umlproject.domain.Project project) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Generates caGrid standard Data Service Metadata for all Classes in the given Packages.
   *
   * @param project
   *	e.g caCore
   * @param packageNames
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForPackages(gov.nih.nci.cadsr.umlproject.domain.Project project,java.lang.String[] packageNames) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Generates caGrid standard Data Service Metadata for all Classes in the given Project, excluding the given Associations.
   *
   * @param project
   *	e.g caCore
   * @param fullClassNames
   * @param associationExcludes
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForClassesWithExcludes(gov.nih.nci.cadsr.umlproject.domain.Project project,java.lang.String[] fullClassNames,gov.nih.nci.cagrid.cadsrservice.UMLAssociationExclude[] associationExcludes) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns all Attributes in the given Class.
   *
   * @param project
   *	e.g caCore
   * @param clazz
   *	caDSR properties of the UML Class in a domain model.
   * @return caDSR properties of a UML Attribute in a UML Class.
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.umlproject.domain.UMLAttributeMetadata[] findAttributesInClass(gov.nih.nci.cadsr.umlproject.domain.Project project,gov.nih.nci.cadsr.umlproject.domain.UMLClassMetadata clazz) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns the SemanticMetadata for the given Class.
   *
   * @param project
   *	e.g caCore
   * @param clazz
   *	caDSR properties of the UML Class in a domain model.
   * @return The group of concept codes in a partivular order that are the unambiguous signature of each of the associated with a particular element in the UML Model.
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.umlproject.domain.SemanticMetadata[] findSemanticMetadataForClass(gov.nih.nci.cadsr.umlproject.domain.Project project,gov.nih.nci.cadsr.umlproject.domain.UMLClassMetadata clazz) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns the ValueDomain for the given Attribute.
   *
   * @param project
   *	e.g caCore
   * @param attribute
   *	caDSR properties of a UML Attribute in a UML Class.
   * @return A set of permissible values for a data element.
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.domain.ValueDomain findValueDomainForAttribute(gov.nih.nci.cadsr.umlproject.domain.Project project,gov.nih.nci.cadsr.umlproject.domain.UMLAttributeMetadata attribute) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns the Associations of the given Class.
   *
   * @param project
   *	e.g caCore
   * @param clazz
   *	caDSR properties of the UML Class in a domain model.
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.cadsrservice.UMLAssociation[] findAssociationsForClass(gov.nih.nci.cadsr.umlproject.domain.Project project,gov.nih.nci.cadsr.umlproject.domain.UMLClassMetadata clazz) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns all Associations in the given Package.
   *
   * @param project
   *	e.g caCore
   * @param packageName
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.cadsrservice.UMLAssociation[] findAssociationsInPackage(gov.nih.nci.cadsr.umlproject.domain.Project project,java.lang.String packageName) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Returns all Associations in the given Project.
   *
   * @param project
   *	e.g caCore
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.cadsrservice.UMLAssociation[] findAssociationsInProject(gov.nih.nci.cadsr.umlproject.domain.Project project) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Generates caGrid standard Data Service Metadata for the given Classes.
   *
   * @param project
   *	e.g caCore
   * @param fullClassNames
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForClasses(gov.nih.nci.cadsr.umlproject.domain.Project project,java.lang.String[] fullClassNames) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

  /**
   * Replaces the UML Class information for all input and outputs of operations, by reading the XML QName information, in a caGrid standard Service Metadata instance.
   *
   * @param serviceMetadata
   */
  public gov.nih.nci.cagrid.metadata.ServiceMetadata annotateServiceMetadata(gov.nih.nci.cagrid.metadata.ServiceMetadata serviceMetadata) throws RemoteException ;

  /**
   * Returns the Context of the given Project.
   *
   * @param project
   *	e.g caCore
   * @return A universe of discourse in which a name or definition is used. (ISO 11179)
   * @throws InvalidProjectException
   *	Thrown if the given Project is null, not valid, or ambiquous.
   */
  public gov.nih.nci.cadsr.domain.Context findContextForProject(gov.nih.nci.cadsr.umlproject.domain.Project project) throws RemoteException, gov.nih.nci.cagrid.cadsr.stubs.types.InvalidProjectException ;

}
